#include "bateau.h"

void placementAlea(TJoueur * pJoueur, int pNbBateau)
{
    int sens;
    while(pNbBateau>0)
    {
        sens = nombreAleatoire(0,1);
        if (sens==horizontal)
        {
            pJoueur->mBateauxDuJoueur[pNbBateau-1].mCoordonnees.mLatitude = nombreAleatoire(1,K_HAUTEURGRILLE);
            pJoueur->mBateauxDuJoueur[pNbBateau-1].mCoordonnees.mLongitude = nombreAleatoire(1,K_LARGEURGRILLE-pJoueur->mBateauxDuJoueur[pNbBateau-1].mType);
            pJoueur->mBateauxDuJoueur[pNbBateau-1].mCoordonnees.mDirection=sens;
        }
        else
        {
            pJoueur->mBateauxDuJoueur[pNbBateau-1].mCoordonnees.mLatitude = nombreAleatoire(1,K_HAUTEURGRILLE-pJoueur->mBateauxDuJoueur[pNbBateau-1].mType);
            pJoueur->mBateauxDuJoueur[pNbBateau-1].mCoordonnees.mLongitude = nombreAleatoire(1,K_LARGEURGRILLE);
            pJoueur->mBateauxDuJoueur[pNbBateau-1].mCoordonnees.mDirection=sens;
        }
        if(checkPos(pJoueur,pNbBateau-1))//Si il n'y a aucun autre bateau sur cette place
        {
            enregistrerPos(pJoueur,pNbBateau-1);
            pNbBateau--; // On passe au bateau suivant!
        }
    }
}

//*******************************

int checkPos(TJoueur * pJoueur, const int pIdBateau)
{
    int tailleBateau=getForme(&(pJoueur->mBateauxDuJoueur[pIdBateau]));

    int * tabPosBatACheck=(int *)malloc(sizeof(int)*tailleBateau);
    if (tabPosBatACheck==NULL) return 0;
    int i,j;
    int ok=1; // est-ce qu'on peut placer le bateau?

    // remplissage des coordonnes du bateau a checker dans le tableau
    if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal)
    {
        for(i=0;i<tailleBateau;i++)
        {
            tabPosBatACheck[i]=pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude*10+pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+i*10;
        }
    }
    else
    {
        for(i=0;i<tailleBateau;i++)
        {
            tabPosBatACheck[i]=pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude*10+pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+i;
        }
    }
    i=0;
    while(i<tailleBateau )
    {
        j=0;
        while(j<pJoueur->nbCasesPrises && ok)
        {
            if(tabPosBatACheck[i]==pJoueur->tabPosBateauJoueur[j])
            {
                ok=0;
            }
            j++;
        }
        i++;
    }

    free(tabPosBatACheck);
    return ok;
}

// *************************************


void placerBateau(Tparam * pParametre)
{
    clrscr();
    saisirPseudo(pParametre->joueur1->nomJoueur);

    clrscr();
    int haut =6;
    int gauche =5;
    int nbBateau; // le nombre de bateau restant  placer
    int i, constNbBateau;
    int touche;
    TInfoBateau* unBateau;

    nbBateau=getNBInstances(pParametre)*K_NBTYPEBATEAUX;  // on compte le nombre de bateau  placer
    constNbBateau=nbBateau; // servira  l'affichage des bateaux dj plac


    // PLACEMENT BATEAU ORDINATEUR
    placementAlea(pParametre->joueur2,nbBateau);
    // PLACEMENT BATEAU JOUEUR1
    if(estAlea())  // SI ON CHOISI LE PLACEMENT ALEATOIRE
    {
        placementAlea(pParametre->joueur1,getNBInstances(pParametre)*K_NBTYPEBATEAUX);
    }
    else
    {
        clrscr();
        afficherGrille(gauche,haut/2,10,10,YELLOW );
        while(nbBateau>0)
        {
            unBateau=getInfoBateau(nbBateau,pParametre);
            afficherInfoPlacement(nbBateau,unBateau->mNom);
            resetGrille(gauche,haut/2); // pour supprimer les fonds de couleur car alors le clrscr ils ne partent pas => prob quand on bouge le bateau
            for(i=constNbBateau-1;i>=nbBateau-1;i--) // affiche du bateau entrain d'tre plac et de ceux dj placs
            {
                afficherBateau(&(pParametre->joueur1->mBateauxDuJoueur[i]),gauche,haut/2);
            }
            touche=getch();
            if (touche=='R') touche='r'; // Pour r & R
            if(actionBateau(pParametre->joueur1,nbBateau-1,touche))
            {
                nbBateau--;
                gotoxy(52+16,6);
                textcolor((LIGHTCYAN)|(BLACK<<4));
                for(i=0;i<K_LGNOM;i++)
                {
                    printf(" ");
                }
            }
        }
        resetGrille(gauche,haut/2);
    }
}

//********************************

void parametrerPartie(Tparam *pParam)
{
    int idBat, indice, codeCouleur,i;
    int nbInstance, type;
    char nomTemporaire[K_LGNOM],couleur[KCOULEURS_LGNOMCOUL];

    idBat=0;
    type=2;

    /*********************************************************/

    clrscr();
    printf("\n\nVous avez au maximum 3 bateaux par type.");

    printf("\nSaisir le nombre d'instances de bateau par type: ");
    scanf("%d",&nbInstance);
    while(nbInstance>K_MAX_BATEAUX || nbInstance <1)
    {
        clrscr();
        printf("\n\nErreur le nombre d'instances de bateau par type doit etre compris entre 1 & 3");
        printf("\nSaisir le nombre d'instances de bateau par type: ");
        scanf("%d",&nbInstance);
    }
    libererParam(pParam);
    newTParam( nbInstance, pParam);

  /** PARAMETRAGE BATEAU HUMAIN**/

    while(type!=6)
    {
        for (indice=0;indice<nbInstance;indice++)
        {
            clrscr();
            printf("\nCodes couleur: ");

            for(i=1;i<=WHITE;i++)
            {
                textcolor(i);

                getNom (getCouleurFromNum(i),couleur);
                printf("%d-%s ",i,couleur);
                if(i%6==5) printf("\n");
            }
            textcolor(LIGHTCYAN);
            printf("\n\n-----");
            afficherType(type);
            printf("%d-----",indice+1);

            do
            {
                printf("\nSaisir le code couleur de votre bateau:");
                scanf("%d",&codeCouleur);
                fflush(stdin);

            }while((codeCouleur<BLUE)||(codeCouleur>WHITE));

            printf("\nSaisir le nom de votre bateau:");
            scanf("%15s",nomTemporaire);
            fflush(stdin);

            setIemeInfoBateauTParam(idBat,pParam,nomTemporaire,codeCouleur,type);
            idBat++;
        }
        type++;
    }

     /** PARAMETRAGE BATEAU MACHINE**/
    // Pas de saisie nous verrons jamais la couleur du bateau ni son nom.
    idBat=nbInstance*4;
    type=2;
    while(type!=6)
    {
        for (indice=0;indice<nbInstance;indice++)
        {
            setIemeInfoBateauTParam(idBat,pParam,"Bruel",indice+5,type);
            idBat++;
        }
        type++;
    }
    pParam->mNombreInstanceBateaux=nbInstance;
}

//***

void checkBateauxCoules(const int pNbBateau, TJoueur * pTireur, TJoueur * pCible)
{
    int i;

    for(i=0;i<pNbBateau;i++) // parcours de tous les bateaux
    {
        if(estCoule(i,pTireur,pCible))
        {
            pCible->mBateauxDuJoueur[i].estCoule=1;
            setCouleurCoupPile(pCible->mBateauxDuJoueur,i,pTireur->pileCoup,1);
        }
        else
        {
            pCible->mBateauxDuJoueur[i].estCoule=0;
            setCouleurCoupPile(pCible->mBateauxDuJoueur,i,pTireur->pileCoup,0);
        }
    }
}
