
#include "jeu.h"


int estGagne(Tparam * pParam)
{
    int nbTouche;
    int gagnant=0;

    nbTouche=getTouche(pParam->joueur2->pileCoup);
    if(nbTouche==pParam->joueur1->nbCasesPrises)
    {
        gagnant=2;
    }
    nbTouche=getTouche(pParam->joueur1->pileCoup);
    if(nbTouche==pParam->joueur2->nbCasesPrises)
    {
        gagnant=1;
    }
    return gagnant;
}

//***************************************

void tir(TJoueur * pTireur, TJoueur * pCible, int * pTour,const int pPosition)
{
    int rate=1,j;
    TCoup unCoup;
    if(tirPossible(pTireur->pileCoup,pPosition)) // si l'on peut tirer
    {
        j=0;
        while(j<pCible->nbCasesPrises && rate==1)
        {
            if(pPosition==pCible->tabPosBateauJoueur[j]) //SI ON TOUCHE
            {
                unCoup.position=pPosition;
                unCoup.couleur=LIGHTRED;
                empiler(pTireur->pileCoup,unCoup);
                *(pTour)+=1;
                rate=0;
            }
            j++;
        }
        if(rate==1) // SI A L'EAU
        {
            unCoup.position=pPosition;
            unCoup.couleur=LIGHTBLUE;
            empiler(pTireur->pileCoup,unCoup);
            *(pTour)+=1;
        }
    }
}

//**************************************

int jouer(Tparam * pParam, const int estReprise)
{
    int estFini=0 ;

    int touche,joueurTour,i,nbBateau,position;
    int quit=0,confirm;
    int gagnant=-2;
    int * curseurX=(int * )malloc(sizeof(int));
    int * curseurY=(int * )malloc(sizeof(int));
    *curseurX=1;
    *curseurY=1;
    clrscr();

    if(!estReprise) // Si l'on a PAS charger la partie depuis une sauvegarde.
    {
        joueurTour=nombreAleatoire(1,2); // 1 -> Joueur1  2 -> Joueur2
        pParam->aCommence=joueurTour;
    }
    else
    {
        joueurTour=getLongPile(pParam->joueur1->pileCoup)+getLongPile(pParam->joueur2->pileCoup)+pParam->aCommence;
    }

    afficherGrille(K_GAUCHE,K_HAUT,10,10,YELLOW );
    afficherGrille(K_GAUCHE + K_DECAL,K_HAUT,10,10,YELLOW );

    nbBateau=getNBInstances(pParam)*K_NBTYPEBATEAUX;

    // affichage des noms
    afficherNom(pParam->joueur1->nomJoueur,1);
    afficherNom(pParam->joueur2->nomJoueur,2);
    while(!estFini)
    {
         // pour les bateaux couls
        checkBateauxCoules(nbBateau,pParam->joueur1,pParam->joueur2);
        checkBateauxCoules(nbBateau,pParam->joueur2,pParam->joueur1);
        // Affichage des bateaux du joueur
        for(i=0;i<nbBateau;i++)
        {
        afficherBateau(&(pParam->joueur1->mBateauxDuJoueur[i]),K_GAUCHE,K_HAUT);
        //afficherBateau(&(pParam->joueur2->mBateauxDuJoueur[i]),K_GAUCHE+K_DECAL,K_HAUT);
        }


        // Affichage des tirs!
        if(!pileVide(pParam->joueur1->pileCoup)) afficherTirs(pParam->joueur1->pileCoup,K_HAUT, K_GAUCHE+K_DECAL);
        if(!pileVide(pParam->joueur2->pileCoup)) afficherTirs(pParam->joueur2->pileCoup,K_HAUT, K_GAUCHE);

        //Affichage des scores
        afficherScore(getScore(pParam->joueur1->pileCoup),1,getTouche(pParam->joueur1->pileCoup),getNbTir(pParam->joueur1->pileCoup));
        afficherScore(getScore(pParam->joueur2->pileCoup),2,getTouche(pParam->joueur2->pileCoup),getNbTir(pParam->joueur2->pileCoup));

        // Affichage des commandes
        afficherTouchesJeu();
        if(joueurTour%2==1) // Si c'est au joueur1
        {

            // Affichage du curseur
            afficherCaractereDansGrille(YELLOW,BLACK, 'O',K_GAUCHE+K_DECAL , K_HAUT, *curseurY, *curseurX);

            //Obtention de la touche
            touche=getch();

            afficherCaractereDansGrille(YELLOW,BLACK, ' ',K_GAUCHE+K_DECAL , K_HAUT, *curseurY, *curseurX); // On efface le curseur

            if(!deplacerCurseur(curseurX,curseurY,touche))
            {
                if (touche==ENTREE)
                {
                position=*curseurX*10+*curseurY;

                tir(pParam->joueur1,pParam->joueur2,&joueurTour,position);
                }
                else
                {
                    if (touche=='z' || touche == 'Z') // on annule le coup si possible
                    {
                        if(joueurTour>pParam->aCommence) // si on est pas au dbut de la partie!
                        {
                                if(joueurTour>pParam->aCommence+1) // alors on est pas au dbut de la partie!
                                {
                                    depiler(pParam->joueur1->pileCoup);
                                    depiler(pParam->joueur2->pileCoup);
                                    joueurTour-=2;
                                }
                                else
                                {
                                    depiler(pParam->joueur2->pileCoup);
                                    joueurTour--;
                                }
                                resetGrille(K_GAUCHE,K_HAUT);
                                resetGrille(K_GAUCHE+K_DECAL,K_HAUT);
                        }
                    }
                    if(touche=='s'|| touche=='S') // on sauvegarde
                    {
                        if(sauverPartie(pParam)==0)
                        {
                            gotoxy(K_GAUCHE+15,32);
                            printf("Une erreur est survenue. Sauvegarde impossible.");
                            getch();
                            gotoxy(K_GAUCHE+15,32);
                            printf("                                               ");
                        }
                        else
                        {
                            gotoxy(K_GAUCHE+15,32);
                            printf("Sauvegarde effectuee. Appuyez sur une touche pour continuer a jouer");
                            getch();
                            gotoxy(K_GAUCHE+15,32);
                            printf("                                                                   ");
                        }
                    }
                    else
                    {
                       if (touche=='Q' || touche == 'q') // on quitte avec confirmation
                        {
                            gotoxy(1,32);
                            confirm=0;
                            printf("Voulez-vous vraiment quitter? La partie est perdue sans sauvegarde.");
                            while(touche!=ENTREE)
                            {
                               gotoxy(1,33);
                               if (confirm!=0) printf("->");
                               else printf("  ");
                               printf("Oui\n");
                               if (confirm==0) printf("->");
                               else printf("  ");
                               printf("Non");
                               touche=getch();
                               switch(touche)
                               {
                               case HAUT:
                                        if (confirm==0) confirm++;
                                    break;
                                case BAS:
                                        if (confirm!=0) confirm--;
                                    break;
                                case ENTREE:
                                        if(confirm==1) quit=1;
                                    else
                                    {
                                        gotoxy(1,32);
                                        printf("                                                                   \n     \n     ");
                                    }
                                    break;
                               }
                            }
                        }
                    }

                }
            }
        }
        else // TOUR ORDI
        {
            *curseurX=nombreAleatoire(1,10);
            *curseurY=nombreAleatoire(1,10);
            position=(*curseurX)*10+(*curseurY);

            tir(pParam->joueur2,pParam->joueur1,&joueurTour,position);

            *curseurX=1;
            *curseurY=1;
        }

        gagnant=estGagne(pParam);

        if(gagnant==2 || gagnant==1 || quit) // si un gagnant a t trouv ou si on veut sauver/quitter
        {
            estFini=1;
            resetGrille(K_GAUCHE,K_HAUT);
            resetGrille(K_GAUCHE+K_DECAL,K_HAUT);
            clrscr();
            textcolor(LIGHTCYAN);
            printf("PARTIE TERMINEE\n\n\n\n\n");
            printf("Appuyez sur une touche pour continuer...");
            getch();
            clrscr();
        }
    }
        return gagnant;
}

//*******************

int tirPossible(TPile* pPile, int pPosition)
{
    int estPossible=1;
    TCellule * cel;
    cel=pPile->debut;
    if(!pileVide(pPile))
    {
        while (cel!=NULL && estPossible==1)
        {
            if(cel->coup.position==pPosition)
            {
                estPossible=0;
            }
            cel=cel->lien;
        }
    }
    return estPossible;
}

//****************************************

int deplacerCurseur(int * pX, int * pY,int pTouche)
{
    int estDeplace=0;
    switch(pTouche)
    {
        case BAS:
                if(*pY<10)
                {
                    *pY+=1;
                    estDeplace=1;
                }
                break;
            case HAUT:
               if(*pY>1)
                {
                    *pY-=1;
                    estDeplace=1;
                }
                break;
            case DROITE:
                if(*pX<10)
                {
                    *pX+=1;
                    estDeplace=1;
                }
                break;
            case GAUCHE:
                if(*pX>1)
                {
                    *pX-=1;
                    estDeplace=1;
                }
                break;
            default:
                return 0;
                break;
    }
    return estDeplace;
}
