#ifndef _JEU_H
#define _JEU_H

#include "../modele/pile.h"
#include "../vue/vue.h"
#include "../vue/score.h"
#include "../modele/sauv.h"
#include "../modele/util.h"
#include "bateau.h"
#include <stdio.h>


//***************************
/*	N : estGagne
	D : Permet de savoir si la partie contenu dans les parametres pParam est gagn par l'un des deux joueurs et si oui donne le gagnant
	E : pParam
	S : -
	R : 0 si partie non finie, 1 si joueur 1 a gagner 2 si joueur 2 a gagner
	Prec : -
*/
int estGagne(Tparam * pParam);

//***************************
/*	N : tir
	D : Controle le tir d'un joueur pTireur sur un joueur pCible durant le tour pTour sur la position pPosition
	E : pTireur pCible pTour pPosition
	S : pTireur pTour
	R : -
	Prec : -
*/
void tir(TJoueur * pTireur, TJoueur * pCible, int * pTour,const int pPosition);


//***************************
/*	N : jouer
	D : Gere la phase de jeu (tirs)
	E : pParam  paramtre de la partie estReprise si reprise d'une sauvegarde 1 oui 0 non
	S : -
	R : une chiffre selon le gagnant ou arrt de la partie ( sauvegarde)
	Prec : bateaux placs parametre initialis
*/
int jouer(Tparam * pParam,const int estReprise);

//***************************
/*	N : tirPossible
	D : Permet de savoir si l'on peut tirer que la position donne pPosition enregistr dans la pile de coup pPile du joueur qui tire ( <=> est-ce qu'on a dj tir l )
	E : pPile
	S : -
	R : estPossible
	Prec : -
*/
int tirPossible(TPile* pPile, int pPosition);

//***************************
/*	N : deplacerCurseur
	D :Permet d'effectuer de dplacer sur la position du cursuer de position pX pY a partir de la touche pTouche
	E : pX pY pTouche
	S : pX pY
	R : si la touche tait dans le switch 1 sinon 0
	Prec : -
    // LONGITUDE => DIZAINE LATITUDE => UNIT
*/
int deplacerCurseur(int * pX, int * pY, int pTouche);








#endif

