#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "modele/util.h"
#include "modele/parametre.h"
#include "vue/vue.h"
#include "vue/lietrec.h"
#include "modele/sauv.h"
#include "vue/vueGrille.h"
#include "modele/random.h"
#include "modele/util.h"
#include "controleur/jeu.h"
#include "controleur/score.h"
#include "vue/menu.h"
#include "vue/score.h"
#include "controleur/menu.h"


int main()
{
    int choixMenu,estPrete,nbtir,nbtouch;
    int gagnant,touche, resultat, aLib=0;
    int continuer=1;
    int nbScore, estResto, noErr;
    Tparam parametre;
    initRandom();// pour initialiser la suite de valeurs alatoires cf util.h
    initConsoleJeu();
    TScore * listeScores;

    afficherStartScreen();
    getch();

    choixMenu=1;
    while(continuer)
    {
        noErr=1;

        afficherMenuPrinc(choixMenu);
        touche=getch(); // sert  rcuprer la touche du clavier pour le dplacement menu
        switch(touche)
        {
            case HAUT:
                if (choixMenu>1) choixMenu--;
                break;
            case BAS:
                if (choixMenu<5) choixMenu++;
                break;
            case ENTREE:
                switch(choixMenu)
                {
                    case 1: // Nouvelle partie
                    if(!aLib)
                    {
                        setParamParDef(&parametre);
                        aLib++;
                    }
                    estPrete=menuNouvellePartie(&parametre);
                    if (estPrete==1)
                    {
                        clrscr();
                        gagnant=jouer(&parametre,0);
                        textcolor(YELLOW);
                        if(gagnant==1)
                        {
                            printf("YOU WIN!");
                            resultat=enregistrerScore(parametre.joueur1);
                            if(!resultat) printf("Une erreur s'est produite.");
                            nbtir=getNbTir(parametre.joueur1->pileCoup);
                            nbtouch= getTouche(parametre.joueur1->pileCoup);

                            printf("\n\nNombre de tirs effectues: %d",nbtir);
                            printf ("\nTirs reussis: %d", nbtouch);
                            printf("\nTirs rates: %d",nbtir-nbtouch);
                            getch();
                        }
                        else
                        {
                           if(gagnant==0)
                           {
                                clrscr();
                           }
                           else
                           {
                                if(gagnant==2) printf("YOU LOOSE\n\n\nVous ferez mieux une autre fois. :)");
                           }
                        }
                        libererParam(&parametre);
                        aLib=0;
                        getch();
                    }
                    break;
                case 2: // Charger Partie
                    // on restaure les parametres sauvegards
                    estResto=restaurerPartie(&parametre);
                    if(estResto)
                    {
                        // on relance le jeu en mode reprise

                        gagnant=jouer(&parametre,1);
                        textcolor(YELLOW);
                        if(gagnant==1)
                        {
                            printf("WINNER");
                            // on enregistre le score de J1
                            enregistrerScore(parametre.joueur1);
                            if(!resultat) printf("Une erreur s'est produite.");
                        //affichage du score

                        }
                        else
                        {
                           if(gagnant==0)
                           {
                                clrscr();
                           }
                           else
                           {
                                if(gagnant==2) printf("YOU LOOSE");
                           }
                        }
                        libererParam(&parametre);

                    }
                    else
                    {
                        tracerLigneH(1,9,25);
                        printf("\nUne erreur s'est produite");
                    }
                    getch();
                    break;
                case 3: // Meilleurs score
                    clrscr();
                    nbScore=getNbScore();
                    if (nbScore!=0)
                    {
                        listeScores = malloc(sizeof(TScore)*nbScore);
                        if(listeScores==NULL) noErr=0;
                        if(noErr)
                        {
                            noErr=chargerScores(listeScores);
                            if(noErr)
                            {
                               afficherMeilleurScore(listeScores,nbScore);
                            }
                            free(listeScores);
                        }
                        else
                        {
                            printf("Une erreur est survenue");
                        }
                        getch();

                    }
                    else printf("Il n'y a pas de score dans le fichier.");
                    break;
                case 4: // Afficher rgles
                    afficherRegles();
                    getch();
                    break;
                case 5:
                    continuer=0;
                    break;
                default:
                    break;
                }
        }


    }
    if(aLib) libererParam(&parametre); // si les parametres ont dj t allous

    return 0;
}
