#include "bateau.h"


void enregistrerPos(TJoueur * pJoueur, const int pIdBateau)
{
    int j;
    for(j=0;j<pJoueur->mBateauxDuJoueur[pIdBateau].mType;j++)
    {
        if( pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal)
        {
             pJoueur->tabPosBateauJoueur[pJoueur->nbCasesPrises]= pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude*10+ pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+j*10;
        }
        else // Si vertical
        {
                 pJoueur->tabPosBateauJoueur[pJoueur->nbCasesPrises]= pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude*10+ pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+j;
        }
    pJoueur->nbCasesPrises++;
    }
}

//***************************

int actionBateau(TJoueur * pJoueur, const int pIdBateau, const int pAction)
{
    int estPlace=0;
    switch(pAction)
    {

        case BAS:
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal&&pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude<10)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude++;
                }
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==vertical&&pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+pJoueur->mBateauxDuJoueur[pIdBateau].mType<11)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude++;
                }
                break;
            case HAUT:
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal&&pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude>1)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude--;

                }
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==vertical&&pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude>1)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude--;
                }
                break;

            case DROITE:
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal&&(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude+pJoueur->mBateauxDuJoueur[pIdBateau].mType)<11)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude++;

                }
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==vertical&&(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude)<10)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude++;

                }
                break;

            case GAUCHE:
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal&&(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude)>1)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude--;

                }
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==vertical&&(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude)>1)
                {
                    pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude--;

                }
                break;
			case 'r': // R ou r => rotation
                if(pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal)
                {
                      while((pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+pJoueur->mBateauxDuJoueur[pIdBateau].mType)> 11)
                      {
                          pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude -= 1;
                      }
                      pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection=vertical;
                }
                else
                {

                      while((pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude+pJoueur->mBateauxDuJoueur[pIdBateau].mType)> 11)
                      {
                          pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude -= 1;
                      }
                      pJoueur->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection=horizontal;
                }
                break;
            case ENTREE:
                    if(checkPos(pJoueur,pIdBateau))//Si il n'y a aucun autre bateau sur cette place
                    {
                        enregistrerPos(pJoueur,pIdBateau);
                        estPlace=1; // On passe au bateau suivant!
                    }
                break;
        }
        return estPlace;
}

//*************************************

int getCouleur(const TInfoBateau * pB)
{
    return pB->mCouleur;
}

//************************************

EType getForme(const TInfoBateau * pB)
{
    return pB->mType;
}

//*************************************

void getBNom(const TInfoBateau * pB, char pNom[])
{
    strcpy(pNom,pB->mNom);
}

//*************************************

TInfoBateau *getInfoBateau(int pNum ,const Tparam * pParam)
{
    if (pNum<K_NBTYPEBATEAUX*getNBInstances (pParam))
        return &(pParam->joueur1->mBateauxDuJoueur[pNum]);
    return &(pParam->joueur2->mBateauxDuJoueur[pNum-K_NBTYPEBATEAUX*getNBInstances (pParam)]);
}

//************************************

int getNbCases(Tparam * pParam)
{
    return getNBInstances(pParam)*(remorqueur+cargot+sousMarin+porteAvion);
}

//************************************


int estCoule(const int pIdBateau, TJoueur * pTireur, TJoueur * pCible)
{
    int j;
    int curPos,nbTouche;
    nbTouche=0;
    for(j=0;j<pCible->mBateauxDuJoueur[pIdBateau].mType;j++) // parcours de toutes les positions du bateau
    {
        if( pCible->mBateauxDuJoueur[pIdBateau].mCoordonnees.mDirection==horizontal)
        {
            curPos=pCible->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude*10+ pCible->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+j*10;
            if(existePos(pTireur->pileCoup,curPos)) nbTouche+=1;
        }
        else // Si vertical
        {
            curPos=pCible->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLongitude*10+ pCible->mBateauxDuJoueur[pIdBateau].mCoordonnees.mLatitude+j;
            if(existePos(pTireur->pileCoup,curPos)) nbTouche+=1;
        }
    }
    if(nbTouche==pCible->mBateauxDuJoueur[pIdBateau].mType)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

