#ifndef _MODEL_BATEAU_H
#define _MODEL_BATEAU_H


#include "structures.h"
#include <string.h>
#include "../controleur/bateau.h"
#include "coup.h"
#include "structures.h"


//***************************
/*	N : enregistrerPos
	D : Permet d'enregistrer la position d'un bateau d'id pIdBateau d'un joueur pJoueur
	E : pIdBateau
	S : pJoueur
	R : -
	Prec : avoir vrifier avec checkPos si il n'y a pas dj un bateau sur l'emplacement souhait. pIdBateau valide
*/
void enregistrerPos(TJoueur * pJoueur, const int pIdBateau);


//***************************
/*	N : actionBateau
	D : Permet d'effectuer une action pAction sur le bateau d'id pIdBateau d'un joueur pJoueur lors du placement (le bouger dans 4 directions, effectuer une rotation, le positionner)
	E : pJoueur, pIdBateau, pAction
	S : pJoueur
	R : 1 si le bateau a t plac 0 sinon
	Prec : -

*/
int actionBateau(TJoueur * pJoueur, const int pIdBateau, const int pAction);


//***************************
/*	N : getCouleur
	D : donne le l'index de la couleur dans la table des couleurs de couleurs.h/.c de la couleur de l'info bateau pB
	E : pB
	S :
	R : le numro de la couleur
	Prec : -
*/
int getCouleur(const TInfoBateau * pB);


//***************************
/*	N : getForme
	D : donne le type de l'info bateau pB
	E : pB
	S :
	R : le numro du type
	Prec : -
*/
EType getForme(const TInfoBateau *pB);


//***************************
/*	N : getNom
	D : donne nom du bateau pB
	E : pB
	S : pNom
	R : -
	Prec : -
*/

void getBNom(const TInfoBateau * pB, char pNom[]);


//***************************
/*	N : getInfoBateau
	D : donne les information sur le pNum eme bateau des parametres de la partie
	E : pNum , pParam
	S : -
	R :  les informations sur le bateau
	Prec : le pNum eme bateau  existe
*/

TInfoBateau *getInfoBateau(int pNum ,const Tparam * pParam);

//***************************
/*	N : getNbCases
	D : Donne le nombre de cases que prennent les bateaux d'un joueur contenu dans le parametre pParam.
	E : pParam
	S : -
	R : le nombre
	Prec : pParam initialis
*/
int getNbCases(Tparam * pParam);

//***************************
/*	N : estCoule
	D : Permet de savoir si le bateau d'id pIdBateau du joueur pCible a t coul par le joueur pTireur
	E : pIdBateau pTireur pCible
	S : -
	R : 1 si coul 0 sinon
	Prec : pIdBateau existe
*/
int estCoule(const int pIdBateau, TJoueur * pTireur, TJoueur * pCible);


#endif



