#ifndef _PARAM_H
#define _PARAM_H

#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include "structures.h"
#include "couleurs.h"
#include "pile.h"
#include "bateau.h"
#define K_NBCOULEURS 4
#define K_NBTYPEBATEAUX 4
#define K_HAUTEURGRILLE 10
#define K_LARGEURGRILLE 10
#define K_MAX_BATEAUX 3 // Nombre maximal de bateaux par type

#define GAUCHE 75
#define DROITE 77
#define HAUT 72
#define BAS 80
#define ENTREE 13

//***************************
/*	N : getNBInstances
	D : donne le nombre d'instances de chaque bateau pour un joueur pour les parametres de partie pParam
	E : pParam
	S :
	R : ce nombre
	Prec : -
*/
int getNBInstances (const Tparam * pParam);

//***************************
/*	N : newTParam
	D : creer un Tparam pour pNbInstances de chaque bateau pour chacun
	E :pNbInstances,
	S : pP
	R :
	Prec : -
*/
void newTParam(int pNbInstances , Tparam * pP);



//***************************
/*	N : libererParam
	D : Permet de librer les parametres pParam de la mmoire
	E : pParam
	S : pParam
	R : -
	Prec : param non dj libr
*/
void libererParam(Tparam * pParam);


//***************************
/*	N : setIemeInfoBateauTParam
	D : COMPLETER
	E  pIdBateau  pNom[] pCouleur  pType
	S : pP
	R :
	Prec : ne peut etre appel qu'apres newTParam
*/
void setIemeInfoBateauTParam(int pIdBateau , Tparam * pP, const char pNom[], int pCouleur , EType pType);

//***************************
/*	N : setParamParDef
	D : Permet de mettre charger les parametres par default dans param
	E : param
	S : param
	R : -
	Prec : ne peut etre appel qu'apres newTParam
*/
void setParamParDef(Tparam *param);

#endif
