#include "sauv.h"

//**************************************
// SAUVEGARDE PARTIE
int sauverBateaux(Tparam *pParam, FILE* pFic)
{
    int nbIns=getNBInstances(pParam);
    int i;
    // on sauvegarde le nombre d'instance de bateaux
    fwrite(&nbIns, sizeof(int), 1, pFic);
    if (ferror(pFic)!= 0) return 0;
    //calcul du nombre de bateau/joueur
    nbIns*=K_NBTYPEBATEAUX;
    // on sauvegarde les bateaux du joueur
    for(i=0;i<nbIns;i++)
    {
        fwrite(&(pParam->joueur1->mBateauxDuJoueur[i]), sizeof(TInfoBateau),1,pFic);
        if (ferror(pFic)!= 0) return 0;
    }

    // puis les bateaux de la machine
    for(i=0;i<nbIns;i++)
    {
        fwrite(&(pParam->joueur2->mBateauxDuJoueur[i]), sizeof(TInfoBateau),1,pFic);
        if (ferror(pFic)!= 0) return 0;
    }
    return 1;
}

//************************************************

int sauverPile(TPile * pPile, FILE* pFic)
{
    int longPile=getLongPile(pPile);
    int i=0;
    // on sauvegarde les piles de coup!
    // pour les deux piles: la longueur de la pile Puis le contenu  chaque fois
    TCellule * uneCel=pPile->debut;
    fwrite(&longPile, sizeof(int), 1, pFic);
    if (ferror(pFic)!= 0) return 0;
    // maintenant les coups

    while(i<longPile)
    {
        fwrite(&(uneCel->coup), sizeof(TCoup), 1, pFic);
        if (ferror(pFic)!= 0) return 0;
        uneCel=uneCel->lien;
        i++;
    }
    return 1;
}

//*************************************************

int sauverPartie(Tparam * pParam)
{
    FILE * ficSave;
    int estSauve; // => pour checker les erreurs
    ficSave = fopen("save.dat","wb");
    if (ficSave==NULL) return 0;

    // on sauvegarde les bateaux!
    estSauve=sauverBateaux(pParam,ficSave);
    if(!estSauve) return 0;
    // Les piles de coup
    estSauve=sauverPile(pParam->joueur1->pileCoup,ficSave);
    if(!estSauve) return 0;
    estSauve=sauverPile(pParam->joueur2->pileCoup,ficSave);
    if(!estSauve) return 0;

    // Sauvegarde des noms des joueurs
    fwrite(pParam->joueur1->nomJoueur, sizeof(char) * K_LGNOM, 1, ficSave);
    if (ferror(ficSave)!= 0) return 0;
    fwrite(pParam->joueur2->nomJoueur, sizeof(char) * K_LGNOM, 1, ficSave);
    if (ferror(ficSave)!= 0) return 0;

    // Sauvegarde de l'id du joueur qui a commenc
    fwrite(&(pParam->aCommence), sizeof(int), 1, ficSave);
    if (ferror(ficSave)!= 0) return 0;

    fclose(ficSave);
    return 1;
}
//*******************************************
// RESTAURATION DE LA SAUVEGARDE
//*******************************************

int restaurerPartie(Tparam * pParam)
{
    int estResto;
    FILE * ficSave=fopen("save.dat","rb");
    if(ficSave==NULL) return 0;
    else
    {
        //On restaure tout
        //les bateaux

        estResto=restaurerBateaux(pParam, ficSave);
        if (!estResto) return 0;
        // les piles de coup

        estResto=restaurerPiles(pParam, ficSave);

        if (!estResto) return 0;

        // restauration  des noms des joueurs
        fread(pParam->joueur1->nomJoueur, sizeof(char) * K_LGNOM, 1, ficSave);
        if (ferror(ficSave)!= 0) return 0;
        fread(pParam->joueur2->nomJoueur, sizeof(char) * K_LGNOM, 1, ficSave);
        if (ferror(ficSave)!= 0) return 0;
        // restauration de l'id du joueur qui a commenc
        fread(&(pParam->aCommence), sizeof(int), 1, ficSave);
        if (ferror(ficSave)!= 0) return 0;
        fclose(ficSave);


    }
    return 1;
}

//*************************************************

int restaurerBateaux(Tparam *pParam, FILE* pFic)
{
    int nbBateau;
    int i;

    // allocation des structures des joueurs
    pParam->joueur1 = (TJoueur * )malloc(sizeof(TJoueur));
    if(pParam->joueur1==NULL) return 0;
    pParam->joueur2 = (TJoueur * )malloc(sizeof(TJoueur));
    if(pParam->joueur2==NULL) return 0;


    fread(&(pParam->mNombreInstanceBateaux), sizeof(int), 1, pFic);
    if (ferror(pFic)!= 0) return 0;


    nbBateau=K_NBTYPEBATEAUX*pParam->mNombreInstanceBateaux;

    i=getNbCases(pParam);

    pParam->joueur1->tabPosBateauJoueur=(int*)malloc(sizeof(int)*i);
    if(pParam->joueur1->tabPosBateauJoueur==NULL) return 0;
    pParam->joueur2->tabPosBateauJoueur=(int*)malloc(sizeof(int)*i);
    if(pParam->joueur2->tabPosBateauJoueur==NULL) return 0;

    pParam->joueur1->mBateauxDuJoueur = (TInfoBateau * )malloc(nbBateau * sizeof(TInfoBateau));
    if(pParam->joueur1->mBateauxDuJoueur==NULL) return 0;

    pParam->joueur2->mBateauxDuJoueur = (TInfoBateau * )malloc(nbBateau * sizeof(TInfoBateau));
    if(pParam->joueur2->mBateauxDuJoueur==NULL) return 0;
    // JOUEUR
    pParam->joueur1->nbCasesPrises=0;
    for(i = 0 ; i < nbBateau ; i++)
    {

        fread(&(pParam->joueur1->mBateauxDuJoueur[i]), sizeof(TInfoBateau), 1, pFic);
        if (ferror(pFic)!= 0) return 0;

        enregistrerPos(pParam->joueur1,i);
    }

    //MACHINE
    pParam->joueur2->nbCasesPrises=0;
    for(i = 0 ; i < nbBateau ; i++)
    {
        fread(&(pParam->joueur2->mBateauxDuJoueur[i]), sizeof(TInfoBateau), 1, pFic);
        if (ferror(pFic)!= 0) return 0;

        enregistrerPos(pParam->joueur2,i);
    }

    return 1;
}

//*******************************************

int restaurerPiles(Tparam *pParam, FILE* pFic)
{
    int longPile;
    int i;
    TCoup unCoup;
    TCellule *cel;
    TCellule *celPrec; // la cellule precedente de cel


            //Recuperation du nombre de coups
        fread(&longPile, sizeof(int), 1, pFic);
        if (ferror(pFic)!= 0) return 0;

        pParam->joueur1->pileCoup=creerPile();

        //Rcupration de la pile de coup.
        for(i = 0 ; i < longPile ; i++)
        {
            fread(&unCoup, sizeof(TCoup), 1, pFic);
            if (ferror(pFic)!= 0) return 0;

            cel =(TCellule*) malloc(sizeof(TCellule));
            if(cel==NULL) return 0;
            cel->coup = unCoup;

            //Si ce n'est pas la premire case on met le lien de la nouvelle case dans la case prcedente.
            // Si c'est la premiere case on fixe le dbut de la pile
            if(i == 0)
            {
                cel->lien=NULL;
                pParam->joueur1->pileCoup->debut=cel;
            }
            else
            {
                celPrec->lien=cel;
                cel->lien=NULL;
            }
            celPrec = cel;
        }

        // JOUEUR2

        fread(&longPile, sizeof(int), 1, pFic);
        if (ferror(pFic)!= 0) return 0;

        pParam->joueur2->pileCoup=creerPile();

        //Rcupration de la pile de coup.
        for(i = 0 ; i < longPile ; i++)
        {
            fread(&unCoup, sizeof(TCoup), 1, pFic);
            cel =(TCellule*) malloc(sizeof(TCellule));
            if(cel==NULL) return 0;

            cel->coup = unCoup;

            //Si ce n'est pas la premire case on met le lien de la nouvelle case dans la case prcedente.
            // Si c'est la premiere case on fixe le dbut de la pile
            if(i == 0)
            {
                cel->lien=NULL;
                pParam->joueur2->pileCoup->debut=cel;
            }
            else
            {
                celPrec->lien=cel;
                cel->lien=NULL;
            }
            celPrec = cel;
        }
    return 1;
}
