#ifndef _STRUCTURES_H
#define _STRUCTURES_H



#define K_LGNOM 15

// ******************PILES************************
typedef
    struct
    {
        int position;  // la position du tir
        int couleur;        // l'id du bateau ou -1 si  l'eau
    }
TCoup;
typedef
    struct cellule
    {
        struct cellule * lien;  // Pointeur vers la cellule suivante
        TCoup  coup;        // la position du tir du coup
    }
TCellule;

typedef
	struct
	{

		TCellule * debut;
	}
TPile;


// ****************BATEAU**********************

typedef enum  {horizontal,  vertical} ESens;

typedef struct
{
    ESens mDirection;
    int mLatitude;
    int mLongitude; /* en fait position dans la grille de jeu du point en haut  gauche */
}   TPosition;


typedef enum  {remorqueur=2,  porteAvion, sousMarin, cargot} EType;

typedef struct
{
     int mCouleur /*indice dans la table des couleurs*/;
     EType mType;
     char mNom[K_LGNOM];
	 TPosition mCoordonnees;
	 int estCoule;
}     TInfoBateau;

// ****************** Joueur *******************************

typedef struct
{
    char  nomJoueur[K_LGNOM];
    TInfoBateau * mBateauxDuJoueur; /*tableau dynamique de mNombreInstanceBateaux*K_NBTYPEBATEAUX bateaux du joueur*/
    int * tabPosBateauJoueur;
    int nbCasesPrises;
    TPile * pileCoup;
}TJoueur;

// **************** PARAMETRE *****************
typedef struct
{
    int mNombreInstanceBateaux;
    TJoueur * joueur1;
    TJoueur * joueur2; // ordi
    int aCommence; // le joueur qui a commence
}Tparam;


//********************SCORE********************

typedef struct
{
    int score;
    int nbTouche;
    int nbTir;
    char nom[K_LGNOM];
} TScore;

#endif
