#include "vue.h"

void afficherCouleur(int pI)
{
    char nom[KCOULEURS_LGNOMCOUL+1];
    getNom (getCouleurFromNum ( pI), nom);
    printf("Couleur : %s\t", nom);
}

//********************************

void afficherParam(const Tparam * pParam)
{
    int i;
    int nbInstance=getNBInstances (pParam);
    int nb = K_NBTYPEBATEAUX*nbInstance;
    printf("Nombre d'instances %d\n", nbInstance);

    for (i=0;i<nb;i++) afficherInfoBateau (&(pParam->joueur1->mBateauxDuJoueur[i]));

    for (i=0;i<nb;i++) afficherInfoBateau (&(pParam->joueur2->mBateauxDuJoueur[i]));
}

//*******************************

void afficherRegles()
{
    clrscr();
    FILE * fic;
    char car;
    fic = fopen ("regles.txt", "r");
    if (fic == NULL) exit (3);

    car = fgetc (fic);
    if ( ferror(fic) ) exit (1);

    while (! feof (fic))
    {
        printf("%c", car);
        car = fgetc (fic);
    if (ferror(fic)) exit (1);
    }
    fclose (fic);
}

//******************************************

void afficherStartScreen()
{
    clrscr();
    FILE * fic;
    char car;
    fic = fopen ("startScreen.txt", "r");
    if (fic != NULL)
    {
        car = fgetc (fic);
        if ( ferror(fic) ) exit (1);

        while (! feof (fic))
        {
            printf("%c", car);
            car = fgetc (fic);
        if (ferror(fic)) exit (1);
        }

    }
    fclose (fic);
}

//***************************

void afficherTirs(TPile* pPile, int pHaut, int pGauche)
{
    TCellule * uneCel=pPile->debut;
    int ligne,colonne;
    while(uneCel!=NULL)
    {
        ligne=uneCel->coup.position%10;
        colonne=uneCel->coup.position/10;
        if(ligne==0)
        {
            ligne=10;
            colonne--;
        }
        afficherCaractereDansGrille(WHITE,uneCel->coup.couleur,'X',pGauche,pHaut,ligne,colonne);
        uneCel=uneCel->lien;
    }
}

//**************************

void afficherNom(char* pNom, const int pIdJoueur)
{
    int x=10;
    if(pIdJoueur==2)
    {
        x=+60;
    }
    textcolor((LIGHTCYAN)|(BLACK<<4));
    gotoxy(x+15,26);
    printf("%s",pNom);
}

//****************

void afficherTouchesJeu(void)
{
    gotoxy( 35,35);
    textcolor(LIGHTCYAN);
    printf("%s","S: Sauvegarder /// Z: Annuler le coup /// Q: Quitter");
}

//***************

void saisirPseudo(char* pPseudo)
{
    printf("\nSaisir votre pseudo:");
    scanf("%15s",pPseudo);
    fflush(stdin);
}
